using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.Web.UI;
using System.Collections.Specialized;

public partial class Commands_ToggleCommand : System.Web.UI.Page
{
	protected void Page_Load(object sender, EventArgs e)
	{

	}

	private void SetCommandState(RadDock dock, DockToggleCommand command)
	{
		ViewState[dock.ClientID + "_" + command.Name] = command.State;
	}

	private DockToggleCommandState GetCommandState(RadDock dock, DockToggleCommand command)
	{
		object state = ViewState[dock.ClientID + "_" + command.Name];
		if (state != null)
		{
			return (DockToggleCommandState)state;
		}
		return command.State;
	}

	protected void RadDock1_Command(object sender, Telerik.Web.UI.DockCommandEventArgs e)
	{
		Label1.Text = string.Format("You clicked a command item with Name '{1}' of RadDock with ID='{0}'.", ((RadDock)sender).ID, e.Command.Name);

		//Unfortunately the custom commands' state is not sent to the server yet. This is in our TODO list
		// and most probably will be implemented in one of the next updates of RadDock. The DockState objects
		// will also allow custom values for storing the custom commands' state.
		DockToggleCommand toggleCommand = e.Command as DockToggleCommand;
		if (toggleCommand != null && !(toggleCommand is DockExpandCollapseCommand))
		{
			//The command state is always the initial. 
			Label1.Text += string.Format(" The command item state is: {0:G}.", toggleCommand.State);

			//With the current version of the control you would have to keep the state information with custom code, 
			// for example in the ViewState.
			DockToggleCommandState state = GetCommandState((RadDock)sender, toggleCommand);
			if (state == DockToggleCommandState.Primary)
			{
				toggleCommand.State = DockToggleCommandState.Alternate;
			}
			else
			{
				toggleCommand.State = DockToggleCommandState.Primary;
			}
			SetCommandState((RadDock)sender, toggleCommand);

			//Now the command has the proper state.
			Label1.Text += string.Format(" The persisted command state is: {0:G}.", toggleCommand.State);
		}
	}
}
